'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var view = require('@codemirror/view');
var state = require('@codemirror/state');
var gutter$1 = require('@codemirror/gutter');

let gutter = new state.Compartment();
function relativeLineNumbers(lineNo, state) {
    if (lineNo > state.doc.lines) {
        return lineNo.toString();
    }
    const cursorLine = state.doc.lineAt(state.selection.asSingle().ranges[0].to).number;
    if (lineNo === cursorLine) {
        return lineNo.toString();
    }
    else {
        return Math.abs(cursorLine - lineNo).toString();
    }
}
// This shows the numbers in the gutter
const showLineNumbers = gutter.of(gutter$1.lineNumbers({ formatNumber: relativeLineNumbers }));
// This ensures the numbers update
// when selection (cursorActivity) happens
const lineNumbersUpdateListener = view.EditorView.updateListener.of((viewUpdate) => {
    if (viewUpdate.selectionSet) {
        viewUpdate.view.dispatch({
            effects: gutter.reconfigure(gutter$1.lineNumbers({ formatNumber: relativeLineNumbers })),
        });
    }
});
function lineNumbersRelative() {
    return [showLineNumbers, lineNumbersUpdateListener];
}

exports.lineNumbersRelative = lineNumbersRelative;
